From bbf091b14ee31480ba6fd0762cad03363e4efd73 Mon Sep 17 00:00:00 2001
From: Ryan Hsu <ryanhsu@qca.qualcomm.com>
Date: Thu, 11 Sep 2014 07:50:39 -0700
Subject: [PATCH 09/18] qcacld: UMAC: Updating the probe response ssid from PE
 session

In the case of multiple bssid, when PE prepares the probe response
template, it should populate the ssid string from PE session
instead of the configuration string, which might store the other
BSS's ssid info.

Change-Id: I0c593b37264db37a5a7704d339c4863c8222592a
CRs-fixed: 723095
---
 CORE/MAC/src/pe/include/schApi.h   |  3 ++-
 CORE/MAC/src/pe/sch/schBeaconGen.c | 35 +++++++++++++++++++++++++++--------
 2 files changed, 29 insertions(+), 9 deletions(-)

diff --git a/CORE/MAC/src/pe/include/schApi.h b/CORE/MAC/src/pe/include/schApi.h
index 111480b..3c45a8b 100644
--- a/CORE/MAC/src/pe/include/schApi.h
+++ b/CORE/MAC/src/pe/include/schApi.h
@@ -93,7 +93,8 @@ void schSetBeaconInterval(tpAniSirGlobal pMac,tpPESession psessionEntry);
 
 tSirRetStatus schSendBeaconReq( tpAniSirGlobal, tANI_U8 *, tANI_U16, tpPESession psessionEntry );
 
-void limUpdateProbeRspTemplateIeBitmapBeacon1(tpAniSirGlobal,tDot11fBeacon1*,tANI_U32*,tDot11fProbeResponse*);
+tSirRetStatus limUpdateProbeRspTemplateIeBitmapBeacon1(tpAniSirGlobal,
+        tDot11fBeacon1*, tpPESession psessionEntry);
 void limUpdateProbeRspTemplateIeBitmapBeacon2(tpAniSirGlobal,tDot11fBeacon2*,tANI_U32*,tDot11fProbeResponse*);
 void SetProbeRspIeBitmap(tANI_U32*,tANI_U32);
 tANI_U32 limSendProbeRspTemplateToHal(tpAniSirGlobal,tpPESession,
diff --git a/CORE/MAC/src/pe/sch/schBeaconGen.c b/CORE/MAC/src/pe/sch/schBeaconGen.c
index 025bfd5..2e83d4f 100644
--- a/CORE/MAC/src/pe/sch/schBeaconGen.c
+++ b/CORE/MAC/src/pe/sch/schBeaconGen.c
@@ -279,9 +279,14 @@ tSirRetStatus schSetFixedBeaconFields(tpAniSirGlobal pMac,tpPESession psessionEn
         vos_mem_set(( tANI_U8* )&(psessionEntry->probeRespFrame),
                     sizeof(psessionEntry->probeRespFrame), 0);
 
-        /* Can be efficiently updated whenever new IE added  in Probe response in future */
-        limUpdateProbeRspTemplateIeBitmapBeacon1(pMac,pBcn1,&psessionEntry->DefProbeRspIeBitmap[0],
-                                                &psessionEntry->probeRespFrame);
+        /* Can be efficiently updated whenever new IE added
+         * in Probe response in future
+         */
+        if (limUpdateProbeRspTemplateIeBitmapBeacon1(pMac, pBcn1,
+                psessionEntry) != eSIR_SUCCESS) {
+                    schLog(pMac, LOGE,
+                        FL("Failed to build ProbeRsp template"));
+        }
     }
 
     nStatus = dot11fPackBeacon1( pMac, pBcn1, ptr,
@@ -515,11 +520,21 @@ tSirRetStatus schSetFixedBeaconFields(tpAniSirGlobal pMac,tpPESession psessionEn
     return eSIR_SUCCESS;
 }
 
-void limUpdateProbeRspTemplateIeBitmapBeacon1(tpAniSirGlobal pMac,
+tSirRetStatus limUpdateProbeRspTemplateIeBitmapBeacon1(tpAniSirGlobal pMac,
                                               tDot11fBeacon1* beacon1,
-                                              tANI_U32* DefProbeRspIeBitmap,
-                                              tDot11fProbeResponse* prb_rsp)
+                                              tpPESession psessionEntry)
 {
+    tANI_U32* DefProbeRspIeBitmap;
+    tDot11fProbeResponse* prb_rsp;
+
+    if (!psessionEntry) {
+        schLog(pMac, LOGE, FL("PESession is null!"));
+        return eSIR_FAILURE;
+    }
+
+    DefProbeRspIeBitmap = &psessionEntry->DefProbeRspIeBitmap[0];
+    prb_rsp = &psessionEntry->probeRespFrame;
+
     prb_rsp->BeaconInterval = beacon1->BeaconInterval;
     vos_mem_copy((void *)&prb_rsp->Capabilities, (void *)&beacon1->Capabilities,
                  sizeof(beacon1->Capabilities));
@@ -528,8 +543,10 @@ void limUpdateProbeRspTemplateIeBitmapBeacon1(tpAniSirGlobal pMac,
     if(beacon1->SSID.present)
     {
         SetProbeRspIeBitmap(DefProbeRspIeBitmap,SIR_MAC_SSID_EID);
-        /* populating it, because probe response has to go with SSID even in hidden case */
-        PopulateDot11fSSID2( pMac, &prb_rsp->SSID );
+        /* populating it, because probe response has to go with
+         * SSID even in hidden case
+         */
+        PopulateDot11fSSID(pMac, &psessionEntry->ssId, &prb_rsp->SSID);
     }
     /* supported rates */
     if(beacon1->SuppRates.present)
@@ -549,6 +566,8 @@ void limUpdateProbeRspTemplateIeBitmapBeacon1(tpAniSirGlobal pMac,
     }
 
     /* IBSS params will not be present in the Beacons transmitted by AP */
+
+    return eSIR_SUCCESS;
 }
 
 void limUpdateProbeRspTemplateIeBitmapBeacon2(tpAniSirGlobal pMac,
-- 
1.8.2

